
<template>
	<div id="app" :class="vueAppClasses">
		<router-view @setAppClasses="setAppClasses" />
	</div>
</template>

<script>
import themeConfig from '@/../themeConfig.ts'
import { Validator } from 'vee-validate'

export default {
  data() {
    return {
      vueAppClasses: [],
    }
  },
  watch: {
    '$store.state.vuexy.vuexy.theme'(val) {
      this.toggleClassInBody(val)
    },
    '$vs.rtl'(val) {
      document.documentElement.setAttribute("dir", val ? "rtl" : "ltr")
    }
  },
  methods: {
    toggleClassInBody(className) {
      if (className == 'dark') {
        if (document.body.className.match('theme-semi-dark')) document.body.classList.remove('theme-semi-dark')
        document.body.classList.add('theme-dark')
      }
      else if (className == 'semi-dark') {
        if (document.body.className.match('theme-dark')) document.body.classList.remove('theme-dark')
        document.body.classList.add('theme-semi-dark')
      }
      else {
        if (document.body.className.match('theme-dark'))      document.body.classList.remove('theme-dark')
        if (document.body.className.match('theme-semi-dark')) document.body.classList.remove('theme-semi-dark')
      }
    },
    setAppClasses(classesStr) {
      this.vueAppClasses.push(classesStr)
    },
    handleWindowResize() {
      this.$store.commit('vuexy/UPDATE_WINDOW_WIDTH', window.innerWidth)

      // Set --vh property
      document.documentElement.style.setProperty('--vh', `${window.innerHeight * 0.01}px`);
    },
    handleScroll() {
      this.$store.commit('vuexy/UPDATE_WINDOW_SCROLL_Y', window.scrollY)
    },
    initValidationLabels() {
          const dictionary = {
      en: {
        messages: {
          max_value: (e, n) => {
            return this.$t('validationMsg.maxValue', { val: n[0] })
          },
          min_value: (e, n) => {
            return this.$t('validationMsg.minValue', { val: n[0] })
          },
          required: (e, n) => {
            return this.$t('validationMsg.required')
          },
          email: (e, n) => {
            return this.$t('validationMsg.email')
          },
          min: (e, n) => {
            return this.$t('validationMsg.min', { val: n[0] })
          },
          max: (e, n) => {
            return this.$t('validationMsg.max', { val: n[0] })
          },
          numeric: (e, n) => {
            return this.$t('validationMsg.numeric')
          },
          integer: (e, n) => {
            return this.$t('validationMsg.integer')
          },
          decimal: (e, n) => {
            return this.$t('validationMsg.decimal')
          },
          alpha: (e, n) => {
            return this.$t('validationMsg.alpha')
          },
          alpha_dash: (e, n) => {
            return this.$t('validationMsg.alphaDash')
          },
          regex: (e, n) => {
            return this.$t('validationMsg.regex')
          },
          ip: (e, n) => {
            return this.$t('validationMsg.ip')
          }
        }
      }
    }

    Validator.localize(dictionary)
    }
  },
  mounted() {
    this.toggleClassInBody(themeConfig.theme)
    this.$store.commit('vuexy/UPDATE_WINDOW_WIDTH', window.innerWidth)

    let vh = window.innerHeight * 0.01;
    // Then we set the value in the --vh custom property to the root of the document
    document.documentElement.style.setProperty('--vh', `${vh}px`);
  },
  async created() {

    let dir = this.$vs.rtl ? "rtl" : "ltr"
    document.documentElement.setAttribute("dir", dir)

    window.addEventListener('resize', this.handleWindowResize)
    window.addEventListener('scroll', this.handleScroll)

    this.initValidationLabels();
  },
  destroyed() {
    window.removeEventListener('resize', this.handleWindowResize)
    window.removeEventListener('scroll', this.handleScroll)
  },
}

</script>
